local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "ANIM", "anim/beard.zip" ),
		
	Asset("ANIM", "anim/player_woodie.zip"),
    Asset("ANIM", "anim/player_wolfgang.zip"),
	
		Asset( "SOUND", "sound/sfx.fsb" ),
		Asset( "SOUND", "sound/wilson.fsb" ),

		Asset("ANIM", "anim/gollum.zip"),
		
		
}
local prefabs = {}

local start_inv = 
{
    "ring",
    "fish",
	"fish",
	"fish",
	"fish",
	
}


local function RandomTalk(sayings) 
    return sayings[math.random(#sayings)]
end

local disallowed_equipment = {

	"fishingrod",

}
 
local function NoFishingrod ( inst, data )
    local item = data.item
    if table.contains( disallowed_equipment, item.prefab ) then
		inst.components.talker:Say("I don't need it! I've hands you fool!")
        inst:DoTaskInTime(0.5, function()
			GetPlayer().components.inventory:DropItem(item)
		end) 
    end
end

local function gollumfood(inst, food)
        if inst.components.eater and food.components.edible.foodtype == "VEGGIE" then
                inst.components.sanity:DoDelta(-20)
                inst.components.talker:Say("Blech!")

        elseif inst.components.eater and food.prefab == "fish" then
                inst.components.sanity:DoDelta(20)
                inst.components.health:DoDelta(20)
                inst.components.hunger:DoDelta(25)
				
		elseif inst.components.eater and food.prefab == "monstermeat" then
                inst.components.sanity:DoDelta(15)
                inst.components.health:DoDelta(25)
				
		elseif inst.components.eater and food.prefab == "cookedmonstermeat" then
                inst.components.sanity:DoDelta(10)
                inst.components.health:DoDelta(3)

		elseif inst.components.eater and food.prefab == "monstermeat_dried" then
                inst.components.sanity:DoDelta(5)
                inst.components.health:DoDelta(3)
			
		elseif inst.components.eater and food:HasTag("rawmeat") then
                inst.components.sanity:DoDelta(15)
		end
				

end



local function noringtalk(inst)
	
		inst.components.talker:Say(RandomTalk(NORING))

end

local function noringtalktimer(inst)
	
	local TalkTime = math.random(25,50)

		inst.talktask = inst:DoPeriodicTask(TalkTime, function() noringtalk(inst) end)
	
end

local function horrorcontrol(inst, data)
		if not inst.components.inventory:Has("ring", 1) and not GetPlayer():HasTag("badring") then
				if not inst.talktask then
					noringtalktimer(inst)
				end
			inst.components.sanity.dapperness = -(100/300)
		else 
			inst.components.sanity.dapperness = 0
			
			if inst.talktask then 
			inst.talktask:Cancel() 
			inst.talktask = nil 
			end	
				
		end
end

local function ringcheck(inst)
	
	local CheckRingTime = 1.8

	inst.ringsanity = inst:DoPeriodicTask(CheckRingTime, function() horrorcontrol(inst) end)

	end

local function induceinsanity(val)
    if GetPlayer().components.sanity then
        GetPlayer().components.sanity.inducedinsanity = val
    end

    local pt = GetPlayer():GetPosition()
    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 100, nil, nil, {'rabbit', 'manrabbit'})

    for k,v in pairs(ents) do
        if v.CheckTransformState ~= nil then
            v.CheckTransformState(v)
        end
    end
end	
	
local function SetHUDState(inst, data)
	
	if GetPlayer():HasTag("badring") and not inst.HUD.gollumOL then
		inst:DoTaskInTime(0.05, function()
		inst.HUD.gollumOL = inst.HUD.under_root:AddChild(Image("images/ring_vision.xml", "ring_vision.tex"))
		inst.HUD.gollumOL:SetVRegPoint(ANCHOR_MIDDLE)
		inst.HUD.gollumOL:SetHRegPoint(ANCHOR_MIDDLE)
		inst.HUD.gollumOL:SetVAnchor(ANCHOR_MIDDLE)
		inst.HUD.gollumOL:SetHAnchor(ANCHOR_MIDDLE)
		inst.HUD.gollumOL:SetScaleMode(SCALEMODE_FILLSCREEN)
		inst.HUD.gollumOL:SetClickable(false)
		
		induceinsanity(true, GetPlayer())
	end)
	
	--[[elseif not GetPlayer():HasTag("badring") then
	
		if inst.HUD.gollumOL then
			inst.HUD.gollumOL:Kill()
			inst.HUD.gollumOL = nil
		end]]
	
	elseif GetPlayer():HasTag("character") and inst.HUD.gollumOL then
		inst.HUD.gollumOL:Kill()
		inst.HUD.gollumOL = nil
		
		induceinsanity(nil, GetPlayer())
	end
end	

local function hudcheck(inst)
	
	local CheckRingTime = 1.5

	inst.ringhud = inst:DoPeriodicTask(CheckRingTime, function() SetHUDState(inst) end)

	end
	
local function nottoomany(inst, data)

if inst.components.inventory:Has("ring", 2) then
	inst.components.inventory:ConsumeByName("ring", 1)	
end

if GetPlayer():HasTag("badring") and inst.components.inventory:Has("ring", 1) then
	inst.components.inventory:ConsumeByName("ring", 1)	
end
end

local fn = function(inst)
	

	inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("gollum.tex")
		

	
	inst.components.eater:SetOnEatFn(gollumfood)
	
--	inst.components.health:SetMaxHealth(140)
--	inst.components.hunger:SetMax(140)
--	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.8)
--	inst.components.sanity:SetMax(160)
	inst.components.sanity.night_drain_mult = 0.5
	inst.components.sanity.neg_aura_mult = 1
--	inst.components.combat.damagemultiplier = 0.75
	
	inst.soundsname = "gollum"
	
	if not inst.ringsanity then
		ringcheck(inst)
	end
	
	if not inst.ringhud then
		hudcheck(inst)
	end
	
	inst:ListenForEvent("itemget", nottoomany)
	
--	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.3)
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.3)
	
	
	inst:ListenForEvent( "equip", NoFishingrod )
	--inst:ListenForEvent( "equip", SetHUDState )
	--inst:ListenForEvent( "unequip", SetHUDState )
		
end


NORING = {
"Where is he? Where is he?",
"We lost our precious! We lost him!",
"Myy PRECIOUS!",
"Poor little me...",
}

return MakePlayerCharacter("gollum", prefabs, assets, fn, start_inv)
