local assets=
{ 
    Asset("ANIM", "anim/ring.zip"),

    Asset("ATLAS", "images/inventoryimages/ring.xml"),
    Asset("IMAGE", "images/inventoryimages/ring.tex"),
	
	Asset("ATLAS", "images/inventoryimages/ringmap.xml"),
    Asset("IMAGE", "images/inventoryimages/ringmap.tex"),
	
}

local prefabs = 
{
}



local function fn(Sim)

    local function OnEquip(inst, owner) 


		owner:AddTag("badring")
		owner:AddTag("notarget")
		owner:RemoveTag("character")

    end

    local function OnUnequip(inst, owner) 
		
		

		owner:RemoveTag("badring")
		owner:RemoveTag("notarget")
		owner:AddTag("character")	
		
    end
	

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)

	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "ringmap.tex" )
    
	inst:AddTag("irreplaceable")
	
    anim:SetBank("ring")
    anim:SetBuild("ring")
    anim:PlayAnimation("idle")
	
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "ring"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/ring.xml"
	
	inst:AddComponent("inspectable")
    	
	inst:AddComponent("spellcaster")
    inst.components.spellcaster:SetSpellFn()
    inst.components.spellcaster.canuseontargets = false
	inst.components.spellcaster.canusefrominventory = false
	inst.components.spellcaster.canuseonpoint = false
		
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( OnEquip )
    inst.components.equippable:SetOnUnequip( OnUnequip )
--    inst.components.equippable.dapperness = -(100/90)
	
    return inst
end

STRINGS.NAMES.RING = "Mystery Ring"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RING = {	
	"My precious!",
	 
}
return  Prefab("common/inventory/ring", fn, assets, prefabs)